(function() {"use strict";var __module = CC_EDITOR ? module : {exports:{}};var __filename = 'preview-scripts/assets/Script/Game/ImageMgr.js';var __require = CC_EDITOR ? function (request) {return cc.require(request, require);} : function (request) {return cc.require(request, __filename);};function __define (exports, require, module) {"use strict";
cc._RF.push(module, 'ecd7bYyYmhMJpmNs6shU0fu', 'ImageMgr', __filename);
// Script/Game/ImageMgr.js

"use strict";

cc.Class({
    extends: cc.Component,

    properties: {
        nodeImage512: cc.Node,
        editImageSize: cc.EditBox,
        editTimerInterval: cc.EditBox,
        labelNumImages: cc.Label
    },

    onLoad: function onLoad() {
        this.nTimerId = null;
        this.nCount = 0;
    },
    onBtnImage512: function onBtnImage512() {
        console.log("** Image");

        var nImageWidth = Number(this.editImageSize.string);
        var nImageHeight = Number(this.editImageSize.string);

        var nColor = -1;
        this.createImage(nImageWidth, nImageHeight, nColor, this.nodeImage512);
    },
    onBtnCreateImage_schedule: function onBtnCreateImage_schedule() {
        if (this.nTimerId !== null) {
            return;
        }

        console.log("** 定时创建图像");
        var nImageWidth = Number(this.editImageSize.string);
        var nImageHeight = Number(this.editImageSize.string);

        var nColor = -1;
        this.createImage_schedule(nImageWidth, nImageHeight, nColor, this.nodeImage512);
    },
    createImage_schedule: function createImage_schedule(nImageWidth, nImageHeight, nColor, nodeParent) {

        this.createImage(nImageWidth, nImageHeight, nColor, nodeParent);

        var that = this;
        var nTimerInterval = Number(this.editTimerInterval.string);
        this.nTimerId = setTimeout(function () {
            that.createImage_schedule(nImageWidth, nImageHeight, nColor, nodeParent);
        }, nTimerInterval);
    },
    stopCreateImage_schedule: function stopCreateImage_schedule() {

        if (this.nTimerId !== null) {
            clearTimeout(this.nTimerId);
            this.nTimerId = null;
            console.log("** stop createImage_schedule()");
        }
    },
    createImage: function createImage(nImageWidth, nImageHeight, nColor, nodeParent) {

        // 销毁之前的节点
        if (nodeParent !== null) {
            var children = nodeParent.children;
            // console.log("old children =", children);
            if (typeof children != 'undefined' && children !== null) {
                for (var j = 0; j < children.length; j++) {
                    var sprite = children[j].getComponent(cc.Sprite);
                    sprite.destroy();
                    children[j].destroy();
                }
                console.log("  destroy", children.length, "node");
            }
        }

        this.nCount++;
        this.labelNumImages.string = this.nCount;

        // 创建canvas
        var canvas = document.createElement('canvas');
        canvas.width = nImageWidth;
        canvas.height = nImageHeight;
        var ctx = canvas.getContext('2d');

        var imageData = ctx.getImageData(0, 0, canvas.width, canvas.height);
        // console.log("imageData.length =", imageData.length, ", imageData =", imageData);

        for (var i = 0; i < imageData.data.length; i++) {
            if (nColor >= 0) {
                imageData.data[i] = nColor;
            } else {
                imageData.data[i] = Math.floor(Math.random() * 255);
            }
        }
        ctx.putImageData(imageData, 0, 0);
        console.log("  create canvas,", this.nCount, ", size =", canvas.width, canvas.height);

        // canvas渲染到node
        var texture2D = new cc.Texture2D();
        texture2D.initWithElement(canvas);

        var node = new cc.Node('Sprite');
        var sprite = node.addComponent(cc.Sprite);

        sprite.spriteFrame = new cc.SpriteFrame();
        sprite.spriteFrame.setTexture(texture2D);

        console.log("  canvas to ndoe");

        // node添加到界面
        node.parent = nodeParent;
    },
    onDestroy: function onDestroy() {}
});

cc._RF.pop();
        }
        if (CC_EDITOR) {
            __define(__module.exports, __require, __module);
        }
        else {
            cc.registerModuleFunc(__filename, function () {
                __define(__module.exports, __require, __module);
            });
        }
        })();
        //# sourceMappingURL=ImageMgr.js.map
        